<template>
  <v-autocomplete
    :items="virtualItems"
    :search-input.sync="search"
    label="ค้นหาพื้นที่"
    hide-no-data
    item-text="name"
    item-value="placeId"
    return-object
    @input="onSelected"
    v-bind="$attrs"
    filled
    rounded
  >
    <template slot="no-data">
      <v-list>
        <v-list-item>
          <v-list-item-title class="text-center">ไม่มีข้อมูล</v-list-item-title>
        </v-list-item>
      </v-list>
    </template>
    <template slot="item" slot-scope="{ item }">
      <v-list>
        <v-list-item>
          <v-list-item-icon>
            <v-icon>place</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title v-text="item.address" />
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </template>
  </v-autocomplete>
</template>

<script>
import { gmapApi } from "vue2-google-maps";
import { GoogleService } from "./google_service/index";
export default {
  computed: {
    virtualItems() {
      if (this.items.length === 0 && this.value) {
        return [this.value];
      } else {
        return this.items;
      }
    },
    google: gmapApi,
  },
  data() {
    return {
      service: null,
      geocoder: null,
      search: null,
      items: [],
    };
  },
  watch: {
    search(newValue) {
      this.loading = true;
      if (newValue) {
        this.service.getPlacePredictions(
          {
            input: this.search,
            componentRestrictions: { country: "th" },
          },
          this.displaySuggestions
        );
      }
    },
  },
  mounted() {
    this.$gmapApiPromiseLazy().then(() => {
      if (this.google) {
        this.geocoder = new this.google.maps.Geocoder();
        this.service = new this.google.maps.places.AutocompleteService();
      }
    });
  },
  methods: {
    displaySuggestions(predictions, status) {
      if (status !== window.google.maps.places.PlacesServiceStatus.OK) {
        this.items = [];
        return;
      }
      this.items = predictions.map((p) => ({
        name: p.structured_formatting.main_text,
        address: p.description,
        placeId: p.place_id,
      }));
    },
    onSelected(selectedItem) {
      if (selectedItem) {
        const { placeId } = selectedItem;
        this.geocoder.geocode({ placeId: placeId }, (results) => {
          let res = GoogleService.googleResult(results, selectedItem);
          this.$emit("addMarker", res);
        });
      }
    },
  },
};
</script>

<style>
</style>